| « PreviousNext » | |
![]() ![]() | Did this page help you? Yes | No | Tell us about it... |
The DELETE operation removes the null version (if there is one) of an
object and inserts a delete marker, which becomes the latest version of the object. If
there isn't a null version, Amazon S3 does not remove any objects.
To remove a specific version, you must be the bucket owner and you must use the
versionId subresource. Using this subresource permanently
deletes the version. If the object deleted is a Delete Marker, Amazon S3 sets the
response header, x-amz-delete-marker, to true.
If the object you want to delete is in a bucket where the bucket versioning configuration
is MFA Delete enabled, you must include the x-amz-mfa request
header in the DELETE versionId request. Requests that include
x-amz-mfa must use HTTPS.
For more information about MFA Delete, go to Using MFA Delete. To see sample requests that use versioning, see Sample Request.
You can delete objects by explicitly calling the DELETE Object API or configure
its lifecycle (see PUT Bucket lifecycle) to enable Amazon S3 to remove them for you. If you want to
block users or accounts from removing or deleting objects from your bucket you must
deny them s3:DeleteObject, s3:DeleteObjectVersion and
s3:PutLifeCycleConfiguration actions.
DELETE /ObjectNameHTTP/1.1 Host:BucketName.s3.amazonaws.com Date:dateContent-Length:lengthAuthorization:signatureValue
This implementation of the operation does not use request parameters.
| Name | Description | Required |
|---|---|---|
x-amz-mfa |
The value is the concatenation of the authentication device's serial number, a space, and the value displayed on your authentication device. Type: String Default: None Condition: Required to permanently delete a versioned object if versioning is configured with MFA Delete enabled. | Conditional |
This implementation of the operation does not use request elements.
| Header | Description |
|---|---|
x-amz-delete-marker |
Specifies whether the versioned object that was permanently
deleted was ( Type: Boolean Valid Values: Default: |
x-amz-version-id |
Returns the version ID of the delete marker created as a
result of the Type: String Default: None |
This implementation of the operation does not return response elements.
This implementation of the operation does not return special errors. For general information about Amazon S3 errors and a list of error codes, see Error Responses.
The following request deletes the object, my-second-image.jpg.
DELETE /my-second-image.jpg HTTP/1.1 Host: bucket.s3.amazonaws.com Date: Wed, 12 Oct 2009 17:50:00 GMT Authorization: AWS AKIAIOSFODNN7EXAMPLE:xQE0diMbLRepdf3YB+FIEXAMPLE= Content-Type: text/plain
HTTP/1.1 204 NoContent x-amz-id-2: LriYPLdmOdAiIfgSm/F1YsViT1LW94/xUQxMsF7xiEb1a0wiIOIxl+zbwZ163pt7 x-amz-request-id: 0A49CE4060975EAC Date: Wed, 12 Oct 2009 17:50:00 GMT Content-Length: 0 Connection: close Server: AmazonS3
The following request deletes the specified version of the object, my-third-image.jpg.
DELETE /my-third-image.jpg?versionId=UIORUnfndfiufdisojhr398493jfdkjFJjkndnqUifhnw89493jJFJ HTTP/1.1 Host: bucket.s3.amazonaws.com Date: Wed, 12 Oct 2009 17:50:00 GMT Authorization: AWS AKIAIOSFODNN7EXAMPLE:xQE0diMbLRepdf3YB+FIEXAMPLE= Content-Type: text/plain Content-Length: 0
HTTP/1.1 204 NoContent x-amz-id-2: LriYPLdmOdAiIfgSm/F1YsViT1LW94/xUQxMsF7xiEb1a0wiIOIxl+zbwZ163pt7 x-amz-request-id: 0A49CE4060975EAC x-amz-version-id: UIORUnfndfiufdisojhr398493jfdkjFJjkndnqUifhnw89493jJFJ Date: Wed, 12 Oct 2009 17:50:00 GMT Content-Length: 0 Connection: close Server: AmazonS3
HTTP/1.1 204 NoContent x-amz-id-2: LriYPLdmOdAiIfgSm/F1YsViT1LW94/xUQxMsF7xiEb1a0wiIOIxl+zbwZ163pt7 x-amz-request-id: 0A49CE4060975EAC x-amz-version-id: 3/L4kqtJlcpXroDTDmJ+rmSpXd3dIbrHY+MTRCxf3vjVBH40Nr8X8gdRQBpUMLUo x-amz-delete-marker: true Date: Wed, 12 Oct 2009 17:50:00 GMT Content-Length: 0 Connection: close Server: AmazonS3
The following request deletes the specified version of the object, my-third-image.jpg, which is stored in an MFA-enabled bucket.
DELETE /my-third-image.jpg?versionId=UIORUnfndfiuf HTTP/1.1
Host: bucket.s3.amazonaws.com
Date: Wed, 12 Oct 2009 17:50:00 GMT
x-amz-mfa:[SerialNumber] [AuthenticationCode]
Authorization: AWS AKIAIOSFODNN7EXAMPLE:xQE0diMbLRepdf3YB+FIEXAMPLE=
Content-Type: text/plain
Content-Length: 0HTTPS/1.1 204 NoContent x-amz-id-2: LriYPLdmOdAiIfgSm/F1YsViT1LW94/xUQxMsF7xiEb1a0wiIOIxl+zbwZ163pt7 x-amz-request-id: 0A49CE4060975EAC x-amz-version-id: UIORUnfndfiuf Date: Wed, 12 Oct 2009 17:50:00 GMT Content-Length: 0 Connection: close Server: AmazonS3